
package com.linkedin.restli.example;

import java.util.List;
import javax.annotation.Generated;
import com.linkedin.data.DataMap;
import com.linkedin.data.schema.PathSpec;
import com.linkedin.data.schema.RecordDataSchema;
import com.linkedin.data.template.DataTemplateUtil;
import com.linkedin.data.template.GetMode;
import com.linkedin.data.template.RecordTemplate;
import com.linkedin.data.template.SetMode;


/**
 * A photo for rest.li
 * 
 */
@Generated(value = "com.linkedin.pegasus.generator.PegasusDataTemplateGenerator", comments = "LinkedIn Data Template. Generated from /Users/jbetz/projects/pegasus/restli-example-api/src/main/pegasus/com/linkedin/restli/example/Photo.pdsc.", date = "Tue Jan 22 17:40:18 PST 2013")
public class Photo
    extends RecordTemplate
{

    private final static Photo.Fields _fields = new Photo.Fields();
    private final static RecordDataSchema SCHEMA = ((RecordDataSchema) DataTemplateUtil.parseSchema("{\"type\":\"record\",\"name\":\"Photo\",\"namespace\":\"com.linkedin.restli.example\",\"doc\":\"A photo for rest.li\",\"fields\":[{\"name\":\"id\",\"type\":\"long\"},{\"name\":\"urn\",\"type\":\"string\"},{\"name\":\"title\",\"type\":\"string\"},{\"name\":\"format\",\"type\":{\"type\":\"enum\",\"name\":\"PhotoFormats\",\"doc\":\"enum type for photo formats\",\"symbols\":[\"BMP\",\"JPG\",\"PNG\"]}},{\"name\":\"exif\",\"type\":{\"type\":\"record\",\"name\":\"EXIF\",\"fields\":[{\"name\":\"isFlash\",\"type\":\"boolean\",\"default\":true,\"optional\":true},{\"name\":\"location\",\"type\":{\"type\":\"record\",\"name\":\"LatLong\",\"fields\":[{\"name\":\"latitude\",\"type\":\"float\",\"optional\":true},{\"name\":\"longitude\",\"type\":\"float\",\"optional\":true}]},\"optional\":true}]},\"doc\":\"Exchangeable image file format\"}]}"));
    private final static RecordDataSchema.Field FIELD_Id = SCHEMA.getField("id");
    private final static RecordDataSchema.Field FIELD_Urn = SCHEMA.getField("urn");
    private final static RecordDataSchema.Field FIELD_Title = SCHEMA.getField("title");
    private final static RecordDataSchema.Field FIELD_Format = SCHEMA.getField("format");
    private final static RecordDataSchema.Field FIELD_Exif = SCHEMA.getField("exif");

    public Photo() {
        super(new DataMap(), SCHEMA);
    }

    public Photo(DataMap data) {
        super(data, SCHEMA);
    }

    public static Photo.Fields fields() {
        return _fields;
    }

    /**
     * Existence checker for id
     * 
     * @see Fields#id
     */
    public boolean hasId() {
        return contains(FIELD_Id);
    }

    /**
     * Remover for id
     * 
     * @see Fields#id
     */
    public void removeId() {
        remove(FIELD_Id);
    }

    /**
     * Getter for id
     * 
     * @see Fields#id
     */
    public Long getId(GetMode mode) {
        return obtainDirect(FIELD_Id, Long.class, mode);
    }

    /**
     * Getter for id
     * 
     * @see Fields#id
     */
    public Long getId() {
        return getId(GetMode.STRICT);
    }

    /**
     * Setter for id
     * 
     * @see Fields#id
     */
    public Photo setId(Long value, SetMode mode) {
        putDirect(FIELD_Id, Long.class, Long.class, value, mode);
        return this;
    }

    /**
     * Setter for id
     * 
     * @see Fields#id
     */
    public Photo setId(Long value) {
        putDirect(FIELD_Id, Long.class, Long.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Setter for id
     * 
     * @see Fields#id
     */
    public Photo setId(long value) {
        putDirect(FIELD_Id, Long.class, Long.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Existence checker for urn
     * 
     * @see Fields#urn
     */
    public boolean hasUrn() {
        return contains(FIELD_Urn);
    }

    /**
     * Remover for urn
     * 
     * @see Fields#urn
     */
    public void removeUrn() {
        remove(FIELD_Urn);
    }

    /**
     * Getter for urn
     * 
     * @see Fields#urn
     */
    public String getUrn(GetMode mode) {
        return obtainDirect(FIELD_Urn, String.class, mode);
    }

    /**
     * Getter for urn
     * 
     * @see Fields#urn
     */
    public String getUrn() {
        return getUrn(GetMode.STRICT);
    }

    /**
     * Setter for urn
     * 
     * @see Fields#urn
     */
    public Photo setUrn(String value, SetMode mode) {
        putDirect(FIELD_Urn, String.class, String.class, value, mode);
        return this;
    }

    /**
     * Setter for urn
     * 
     * @see Fields#urn
     */
    public Photo setUrn(String value) {
        putDirect(FIELD_Urn, String.class, String.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Existence checker for title
     * 
     * @see Fields#title
     */
    public boolean hasTitle() {
        return contains(FIELD_Title);
    }

    /**
     * Remover for title
     * 
     * @see Fields#title
     */
    public void removeTitle() {
        remove(FIELD_Title);
    }

    /**
     * Getter for title
     * 
     * @see Fields#title
     */
    public String getTitle(GetMode mode) {
        return obtainDirect(FIELD_Title, String.class, mode);
    }

    /**
     * Getter for title
     * 
     * @see Fields#title
     */
    public String getTitle() {
        return getTitle(GetMode.STRICT);
    }

    /**
     * Setter for title
     * 
     * @see Fields#title
     */
    public Photo setTitle(String value, SetMode mode) {
        putDirect(FIELD_Title, String.class, String.class, value, mode);
        return this;
    }

    /**
     * Setter for title
     * 
     * @see Fields#title
     */
    public Photo setTitle(String value) {
        putDirect(FIELD_Title, String.class, String.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Existence checker for format
     * 
     * @see Fields#format
     */
    public boolean hasFormat() {
        return contains(FIELD_Format);
    }

    /**
     * Remover for format
     * 
     * @see Fields#format
     */
    public void removeFormat() {
        remove(FIELD_Format);
    }

    /**
     * Getter for format
     * 
     * @see Fields#format
     */
    public PhotoFormats getFormat(GetMode mode) {
        return obtainDirect(FIELD_Format, PhotoFormats.class, mode);
    }

    /**
     * Getter for format
     * 
     * @see Fields#format
     */
    public PhotoFormats getFormat() {
        return getFormat(GetMode.STRICT);
    }

    /**
     * Setter for format
     * 
     * @see Fields#format
     */
    public Photo setFormat(PhotoFormats value, SetMode mode) {
        putDirect(FIELD_Format, PhotoFormats.class, String.class, value, mode);
        return this;
    }

    /**
     * Setter for format
     * 
     * @see Fields#format
     */
    public Photo setFormat(PhotoFormats value) {
        putDirect(FIELD_Format, PhotoFormats.class, String.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    /**
     * Existence checker for exif
     * 
     * @see Fields#exif
     */
    public boolean hasExif() {
        return contains(FIELD_Exif);
    }

    /**
     * Remover for exif
     * 
     * @see Fields#exif
     */
    public void removeExif() {
        remove(FIELD_Exif);
    }

    /**
     * Getter for exif
     * 
     * @see Fields#exif
     */
    public EXIF getExif(GetMode mode) {
        return obtainWrapped(FIELD_Exif, EXIF.class, mode);
    }

    /**
     * Getter for exif
     * 
     * @see Fields#exif
     */
    public EXIF getExif() {
        return getExif(GetMode.STRICT);
    }

    /**
     * Setter for exif
     * 
     * @see Fields#exif
     */
    public Photo setExif(EXIF value, SetMode mode) {
        putWrapped(FIELD_Exif, EXIF.class, value, mode);
        return this;
    }

    /**
     * Setter for exif
     * 
     * @see Fields#exif
     */
    public Photo setExif(EXIF value) {
        putWrapped(FIELD_Exif, EXIF.class, value, SetMode.DISALLOW_NULL);
        return this;
    }

    public static class Fields
        extends PathSpec
    {


        public Fields(List<String> path, String name) {
            super(path, name);
        }

        public Fields() {
            super();
        }

        public PathSpec id() {
            return new PathSpec(getPathComponents(), "id");
        }

        public PathSpec urn() {
            return new PathSpec(getPathComponents(), "urn");
        }

        public PathSpec title() {
            return new PathSpec(getPathComponents(), "title");
        }

        public PathSpec format() {
            return new PathSpec(getPathComponents(), "format");
        }

        /**
         * Exchangeable image file format
         * 
         */
        public com.linkedin.restli.example.EXIF.Fields exif() {
            return new com.linkedin.restli.example.EXIF.Fields(getPathComponents(), "exif");
        }

    }

}
