
package com.linkedin.restli.example.photos;

import java.util.ArrayList;
import java.util.Collections;
import java.util.EnumSet;
import java.util.HashMap;
import javax.annotation.Generated;
import com.linkedin.data.template.DataTemplateUtil;
import com.linkedin.data.template.DynamicRecordMetadata;
import com.linkedin.data.template.FieldDef;
import com.linkedin.restli.common.CompoundKey;
import com.linkedin.restli.common.ResourceMethod;
import com.linkedin.restli.common.ResourceSpec;
import com.linkedin.restli.common.ResourceSpecImpl;
import com.linkedin.restli.example.AlbumEntry;


/**
 * Many-many association between photos and albums.
 * 
 *  <pre>
 *    new AlbumEntryBuilders().findBySearch()
 *      .albumIdParam(5)
 *      .photoIdParam(100)
 *      .build();
 *  </pre>
 * 
 * generated from: com.linkedin.restli.example.impl.AlbumEntryResource
 * 
 */
@Generated(value = "com.linkedin.restli.tools.clientgen.RestRequestBuilderGenerator", comments = "LinkedIn Request Builder. Generated from /Users/jbetz/projects/pegasus/restli-example-api/src/main/idl/com.linkedin.restli.example.photos.albumEntry.restspec.json.", date = "Tue Jan 22 17:40:22 PST 2013")
public class AlbumEntryBuilders {

    private final String _baseUriTemplate;
    private final static ResourceSpec _resourceSpec;

    static {
        HashMap<String, Class<?>> keyParts = new HashMap<String, Class<?>>();
        keyParts.put("albumId", Long.class);
        keyParts.put("photoId", Long.class);
        HashMap<String, DynamicRecordMetadata> requestMetadataMap = new HashMap<String, DynamicRecordMetadata>();
        ArrayList<FieldDef<?>> purgeParams = new ArrayList<FieldDef<?>>();
        purgeParams.add(new FieldDef<Long>("albumId", Long.class, DataTemplateUtil.getSchema(Long.class)));
        purgeParams.add(new FieldDef<Long>("photoId", Long.class, DataTemplateUtil.getSchema(Long.class)));
        requestMetadataMap.put("purge", new DynamicRecordMetadata("purge", purgeParams));
        HashMap<String, DynamicRecordMetadata> responseMetadataMap = new HashMap<String, DynamicRecordMetadata>();
        responseMetadataMap.put("purge", new DynamicRecordMetadata("purge", Collections.singletonList(new FieldDef<Integer>("value", Integer.class, DataTemplateUtil.getSchema(Integer.class)))));
        _resourceSpec = new ResourceSpecImpl(EnumSet.of(ResourceMethod.GET, ResourceMethod.BATCH_GET, ResourceMethod.UPDATE, ResourceMethod.DELETE), requestMetadataMap, responseMetadataMap, CompoundKey.class, null, null, AlbumEntry.class, keyParts);
    }

    public AlbumEntryBuilders() {
        _baseUriTemplate = "albumEntry";
    }

    public AlbumEntryBuilders(String primaryResourceName) {
        _baseUriTemplate = primaryResourceName;
    }

    /**
     * Remove the specified photo from the specified album
     * 
     * @return
     *     builder for the resource method
     */
    public AlbumEntryDeleteBuilder delete() {
        return new AlbumEntryDeleteBuilder(_baseUriTemplate, _resourceSpec);
    }

    /**
     * Retrieve the photo's album entry
     * 
     * @return
     *     builder for the resource method
     */
    public AlbumEntryGetBuilder get() {
        return new AlbumEntryGetBuilder(_baseUriTemplate, _resourceSpec);
    }

    public AlbumEntryBatchGetBuilder batchGet() {
        return new AlbumEntryBatchGetBuilder(_baseUriTemplate, _resourceSpec);
    }

    /**
     * Add the specified photo to the specified album.
     *  If a matching pair of IDs already exists, this changes the add date.
     * 
     * @return
     *     builder for the resource method
     */
    public AlbumEntryUpdateBuilder update() {
        return new AlbumEntryUpdateBuilder(_baseUriTemplate, _resourceSpec);
    }

    /**
     * Find all entries matching the given album and photo IDs. <code>null</code> is treated
     *  as a wildcard.
     * 
     * @return
     *     builder for the resource method
     */
    public AlbumEntryFindBySearchBuilder findBySearch() {
        return new AlbumEntryFindBySearchBuilder(_baseUriTemplate, _resourceSpec);
    }

    /**
     * Delete all entries in the db with matching album/photo IDs. If either albumId or photoId
     *  params are not supplied they are treated as a wildcard.
     * 
     * @return
     *     builder for the resource method
     */
    public AlbumEntryDoPurgeBuilder actionPurge() {
        return new AlbumEntryDoPurgeBuilder(_baseUriTemplate, Integer.class, _resourceSpec);
    }

    public static class Key
        extends CompoundKey
    {


        public Key() {
        }

        public AlbumEntryBuilders.Key setAlbumId(Long albumId) {
            append("albumId", albumId);
            return this;
        }

        public Long getAlbumId() {
            return ((Long) getPart("albumId"));
        }

        public AlbumEntryBuilders.Key setPhotoId(Long photoId) {
            append("photoId", photoId);
            return this;
        }

        public Long getPhotoId() {
            return ((Long) getPart("photoId"));
        }

    }

}
